<template>
  <div
    class="progress-container q-px-lg"
    style="margin-top: 100px; margin-bottom: -110px"
  >
    <div
      class="q-pt-lg"
      v-if="
        userStore.isResumeUploaded === null ||
        userStore.isProfileUploaded === null
      "
    >
      <q-card elevated class="q-pa-lg rounded-borders-10">
        <div class="row">
          <div
            class="title-headline text__tertiary q-my-md"
            :class="$q.screen.lt.md ? 'col-12' : 'col-3'"
          >
            Complete your profile by uploading:
          </div>
          <div class="col-9" v-if="$q.screen.lt.sm"></div>
          <div class="q-my-auto" :class="$q.screen.lt.md ? 'col-6' : 'col-3'">
            <q-radio
              v-model="userStore.isResumeUploaded"
              class="title-headline text__regular font-weight-bold"
              label="CV / Resume"
              checked-icon="task_alt"
              unchecked-icon="panorama_fish_eye"
              val="resume"
              :style="{
                'font-size': $q.screen.lt.sm
                  ? '14px'
                  : $q.screen.lt.md
                  ? '15px'
                  : '17px',
              }"
              :size="$q.screen.lt.md ? 'md' : 'lg'"
              disable
            />
            <q-btn
              unelevated
              label="UPLOAD"
              @click="showUploadResumeDialog = true"
              class="btn-md btn--shade-1 text-white q-ml-xl"
            />
          </div>

          <div class="col-6 q-my-auto">
            <q-radio
              v-model="userStore.isProfileUploaded"
              class="title-headline text__regular font-weight-bold"
              label="Profile Photo"
              checked-icon="task_alt"
              unchecked-icon="panorama_fish_eye"
              val="profile"
              :style="{
                'font-size': $q.screen.lt.sm
                  ? '14px'
                  : $q.screen.lt.md
                  ? '15px'
                  : '17px',
              }"
              :size="$q.screen.lt.md ? 'md' : 'lg'"
              disable
            />
            <q-btn
              unelevated
              label="UPLOAD"
              @click="showUploadProfileDialog = true"
              class="btn-md btn--shade-1 text-white q-ml-xl"
            />
          </div>
        </div>
      </q-card>
    </div>
  </div>

  <!-- DIALOG: UPLOAD CV/RESUME -->
  <q-dialog
    v-model="showUploadResumeDialog"
    persistent
    @hide="showUploadResumeDialog === false"
  >
    <q-card
      flat
      class="q-pa-sm q-mt-lg rounded-borders-10"
      style="width: 600px; max-width: 80vw"
    >
      <q-card-section class="row items-center q-pb-none">
        <span class="title-headline text-dark">Upload CV / Resume</span>
        <q-space />
        <q-btn size="md" icon="eva-close" flat round dense v-close-popup />
      </q-card-section>

      <q-card-section>
        <div>
          <q-file
            outlined
            v-model="resumeForm.cv_or_resume"
            max-file-size="5242880"
            :rules="[validations.requiredField]"
            :filter="checkFileType"
            @rejected="onRejected"
          >
            <template v-slot:prepend>
              <q-icon name="eva-attach-outline" />
            </template>
          </q-file>
          <p id="error" class="q-field_messages text-negative q-pa-sm">
            {{ errorMessage }}
          </p>
        </div>
      </q-card-section>

      <div class="q-my-md" align="center">
        <q-btn
          unelevated
          label="UPLOAD"
          class="btn-md btn--shade-1 text-white q-mr-sm"
          :loading="loading"
          @click="confirmUploadResume(resumeForm)"
        />
      </div>
    </q-card>
  </q-dialog>

  <!-- DIALOG: UPLOAD PROFILE PICTURE -->
  <q-dialog
    v-model="showUploadProfileDialog"
    persistent
    @hide="showUploadProfileDialog === false"
  >
    <q-card class="q-pa-sm q-mt-lg" style="width: 600px; max-width: 80vw">
      <q-card-section class="row items-center q-pb-none">
        <span class="title-headline text-dark">Upload Profile Photo</span>
        <q-space />
        <q-btn size="md" icon="eva-close" flat round dense v-close-popup />
      </q-card-section>

      <q-card-section>
        <div>
          <q-file
            outlined
            v-model="profileForm.profile_picture"
            max-file-size="5242880"
            :rules="[validations.requiredField]"
            :filter="checkFileTypeProfile"
            @rejected="onRejected"
          >
            <template v-slot:prepend>
              <q-icon name="eva-attach-outline" />
            </template>
          </q-file>
          <p id="error" class="q-field_messages text-negative q-pa-sm">
            {{ errorMessage }}
          </p>
        </div>
      </q-card-section>

      <div class="q-my-md" align="center">
        <q-btn
          unelevated
          label="UPLOAD"
          class="btn-md btn--shade-1 text-white q-mr-sm"
          :loading="loading"
          @click="confirmUploadProfile(profileForm)"
        />
      </div>
    </q-card>
  </q-dialog>
</template>

<script>
import { LocalStorage } from "quasar";
import { defineComponent, ref, reactive } from "vue";
import { requiredField } from "src/hooks/validations";
import { JobseekerUserApi } from "src/hooks/api";
import useNotification from "src/hooks/notification";
import { useUser } from "src/layouts/portals/store/user";

export default defineComponent({
  name: "ProgressHeader",
  setup() {
    const userStore = useUser();
    const { getBasicInfo } = userStore;

    // const isResumeUploaded = ref(null);
    // const isProfileUploaded = ref(null);
    const showUploadResumeDialog = ref(false);
    const showUploadProfileDialog = ref(false);
    const isError = ref(false);
    const errorMessage = ref("");
    const loading = ref(false);
    const { showNotif } = useNotification();
    const resumeForm = reactive({
      cv_or_resume: null,
      _method: "PUT",
    });

    const profileForm = reactive({
      profile_picture: null,
      _method: "PUT",
    });

    const confirmUploadResume = async (form) => {
      loading.value = true;
      let user_id = LocalStorage.getItem("auth").id;
      const formData = new FormData();
      formData.append(
        "cv_or_resume",
        form.cv_or_resume,
        form.cv_or_resume.name
      );
      formData.append("_method", form._method);

      await JobseekerUserApi.updateResume(user_id, formData)
        .then((response) => {
          console.log("response: ", response);

          let data = LocalStorage.getItem("auth");
          data.cv_or_resume = response.data.data.cv_or_resume;
          data.cv_or_resume_url = response.data.data.cv_or_resume_url;
          LocalStorage.set("auth", data);

          showNotif({
            message: "You have successfully uploaded your resume",
            color: "positive",
            position: "bottom-right",
          });

          // isResumeUploaded.value = "resume";
          showUploadResumeDialog.value = false;
        })
        .catch((error) => {
          showNotif({
            message: error?.response?.data?.message || "Invalid credentials.",
            color: "negative",
            position: "bottom-right",
          });
        })
        .finally(() => {
          loading.value = false;
        });
    };

    const confirmUploadProfile = async (form) => {
      loading.value = true;
      let user_id = LocalStorage.getItem("auth").id;
      const formData = new FormData();
      formData.append(
        "profile_picture",
        form.profile_picture,
        form.profile_picture.name
      );
      formData.append("_method", form._method);

      await JobseekerUserApi.updatePhoto(user_id, formData)
        .then(() => {
          showNotif({
            message: "You have successfully uploaded your profile photo",
            color: "positive",
            position: "bottom-right",
          });

          getBasicInfo(user_id);

          // isProfileUploaded.value = "profile";
          showUploadProfileDialog.value = false;
        })
        .catch((error) => {
          showNotif({
            message: error?.response?.data?.message || "Invalid credentials.",
            color: "negative",
            position: "bottom-right",
          });
        })
        .finally(() => {
          loading.value = false;
        });
    };

    // const fetchUserDetails = async () => {
    //   let user_id = LocalStorage.getItem("auth").id;

    //   await JobseekerUserApi.show(user_id).then((response) => {
    //     if (response.data.data.cv_or_resume !== null) {
    //       isResumeUploaded.value = "resume";
    //     }
    //
    //     if (response.data.data.profile_picture !== null) {
    //       isProfileUploaded.value = "profile";
    //     }
    //   });
    // };

    // fetchUserDetails();

    return {
      userStore,
      resumeForm,
      profileForm,
      loading,
      // isResumeUploaded,
      // isProfileUploaded,
      showUploadResumeDialog,
      showUploadProfileDialog,
      errorMessage,
      validations: {
        requiredField,
      },
      checkFileType(files) {
        isError.value = false;
        errorMessage.value = "";
        return files.filter(
          (file) =>
            file.type === "application/msword" ||
            file.type ===
              "application/vnd.openxmlformats-officedocument.wordprocessingml.document" ||
            file.type === "application/pdf" ||
            file.type === "image/jpg" ||
            file.type === "image/png" ||
            file.type === "image/jpeg"
        );
      },
      checkFileTypeProfile(files) {
        return files.filter(
          (file) =>
            file.type === "image/jpeg" ||
            file.type === "image/png" ||
            file.type === "image/jpg"
        );
      },
      onRejected(files) {
        for (let x = 0; x < files.length; x++) {
          const file = files[x];

          if (file.failedPropValidation === "max-file-size") {
            isError.value = true;
            errorMessage.value = "File size should not be greater than 5MB";
          } else if (file.failedPropValidation === "filter") {
            isError.value = true;
            errorMessage.value = "The file type uploaded is not supported";
          } else {
            isError.value = false;
            errorMessage.value = "";
          }
        }
      },
      confirmUploadResume,
      confirmUploadProfile,
    };
  },
});
</script>

<style lang="scss" scoped>
.progress-container {
  background-color: #f1f1f1;
}

.q-card {
  background-color: #ffffff;
  box-shadow: 0px 2px 4px rgba(0, 0, 0, 0.25);
  border-radius: 10px;
}
</style>
